/*
 * Copyright 2015 Fadri Furrer, ASL, ETH Zurich, Switzerland
 * Copyright 2015 Michael Burri, ASL, ETH Zurich, Switzerland
 * Copyright 2015 Mina Kamel, ASL, ETH Zurich, Switzerland
 * Copyright 2015 Janosch Nikolic, ASL, ETH Zurich, Switzerland
 * Copyright 2015 Markus Achtelik, ASL, ETH Zurich, Switzerland
 * Copyright 2018-2020 Vincent LE DOZE, INRIA, Chroma Team, CITI Lab Lyon, France
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0

 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef GAZEBO_PLUGINS_ROTOR_H_
#define GAZEBO_PLUGINS_ROTOR_H_

#include "gazebo_plugins/common.h"

#include <ros/callback_queue.h>

#include <chroma_gazebo_plugins_msgs/Rotorspeed.h>
#include <std_msgs/Float32.h>


namespace turning_direction {
const static int CCW = 1;
const static int CW = -1;
}

namespace gazebo {
// Default values
static const std::string KDEFAULT_NAMESPACE = "";
static const std::string KDEFAULT_TOPIC_ROTORSPEED_CMD = "command/rotorspeed";
static const std::string KDEFAULT_TOPIC_ROTORSPEED_VAL = "rotorspeed";

static constexpr double KDEFAULT_BODYSPEED_MAX = 50.0; // m/s
static constexpr double KDEFAULT_ROTORSPEED_MAX = 838.0; // rad/s
static constexpr double KDEFAULT_THRUST_CONSTANT = 8.54858E-06;
static constexpr double KDEFAULT_TORQUE_CONSTANT = 0.016*8.54858E-06;
static constexpr double KDEFAULT_ROTOR_DRAG_COEF = 1.0e-4;
static constexpr double KDEFAULT_ROTOR_MOMENT_COEF = 1.0e-6;

static constexpr double KDEFAULT_FILTER_TIME_CONSTANT_UP = 1.0 / 80.0;
static constexpr double KDEFAULT_FILTER_TIME_CONSTANT_DOWN = 1.0 / 40.0;
static constexpr double KDEFAULT_ROTOR_VELOCITY_SLOWDOWN_SIM = 10.0;

// Set the max_force_ to the max double value. The limitations get handled by the FirstOrderFilter.
static constexpr double KDEFAULT_MAXFORCE = std::numeric_limits<double>::max();

/// \brief A plugin that simulate an the rotor physics
class GAZEBO_VISIBLE RotorModel : public ModelPlugin {

  /// Methods //////////////////////////////////////////////////////////
  public:
    RotorModel();   /// \brief Constructor.
    ~RotorModel();  /// \brief Destructor.

    /// \brief Publish ROS msgs
    virtual void Publish();

  protected:
    /// \brief Load model parameters
    virtual void Load(physics::ModelPtr _in_model, sdf::ElementPtr _in_sdf);
    /// \brief Reset function
    virtual void Reset();
    /// \brief Load model parameters
    virtual void OnUpdate(const common::UpdateInfo & /*_info*/);
    /// \brief Update Force and Moments generated by the rotor
    virtual void UpdateForcesAndMoments();
    /// \brief Get the real rotorspeed
    virtual void GetRotorSpeed();
    /// \brief Set the rotorspeed
    virtual void SetRotorSpeed();

  private:
    /// \brief
    void CallbackRotorspeedCmd(const chroma_gazebo_plugins_msgs::Rotorspeed& msg_rotorspeed_cmd);

  /// Attributes ///////////////////////////////////////////////////////
  protected:
    /// Gazebo related ///////////////////////////////////////////////
    physics::WorldPtr world_;
    physics::ModelPtr model_;
    physics::JointPtr joint_;
    physics::LinkPtr link_;

    /// \brief Pointer to the update event connection.
    event::ConnectionPtr update_connection_ptr_;

    /// ROS related //////////////////////////////////////////////////
    ros::NodeHandle* node_handle_;
    ros::Publisher   pub_rotorspeed_val_;
    ros::Subscriber  sub_rotorspeed_cmd_;

    /// SDF parameters ///////////////////////////////////////////////
    /// \brief
    std::string namespace_;
    /// \brief
    std::string link_name_;
    /// \brief
    std::string joint_name_;
    /// \brief topic name for the rotor speed control
    std::string topic_rotorspeed_cmd_;
    /// \brief topic name for the rotor speed value
    std::string topic_rotorspeed_val_;

    /// \brief
    int rotor_id_;
    /// \brief
    int turning_direction_;

    /// \brief
    double max_force_;
    /// \brief
    double bodyspeed_max_;
    /// \brief
    double rotorspeed_max_;
    /// \brief
    double thrust_constant_;
    /// \brief
    double torque_constant_;
    /// \brief
    double rotor_drag_coef_;
    /// \brief
    double rotor_moment_coef_;
    /// \brief
    double rotor_velocity_slowdown_sim_;
    /// \brief
    double filter_time_constant_down_;
    /// \brief
    double filter_time_constant_up_;

    /// Rotor description ///////////////////////////////////////////
    /// \brief Reel rotor speed
    double rotorspeed_;
    /// \brief Commanded rotor speed
    double rotorspeed_cmd_;
    /// \brief Filtered commanded rotor speed
    double rotorspeed_cmd_filt_;
    /// \brief
    double last_time_;
    /// \brief
    double sampling_time_;

    /// First Order filter /////////////////////////////////////////
    std::unique_ptr<FirstOrderFilter<double>>  rotorspeed_filter_;
};

}
#endif // GAZEBO_PLUGINS_ROTOR_H_
